﻿@using System.Web.UI.WebControls;

@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;

@using Portal.Models.Delivery.Invoice;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.DevExpress().GridView(
        setting =>
        {
            setting.Name = "GridDeliveryInvoice";
            //setting.KeyFieldName = "DELIVERY_NO;AMOUNT;PO_NO;INVOICE_NO";
            setting.KeyFieldName = "DATA_KEY";
            setting.CallbackRouteValues = new { Controller = "D31401", Action = "PartialListData" };
            //setting.ClientSideEvents.Init = "gridDeliveryInvoice_Init";
            //setting.ClientSideEvents.CustomButtonClick = "func";
            setting.ClientSideEvents.Init = "grid_init";
            setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
            setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
            setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
            setting.Width = Unit.Percentage(100);
            
            //setting.SettingsDetail.MasterGridName = "grid";
            setting.Settings.ShowFilterRow = true;
            setting.Settings.ShowFilterRowMenu = true;
            //setting.Settings.ShowFilterRowMenuLikeItem = true;

            setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
            setting.SettingsBehavior.AllowSelectByRowClick = false;
                     
                        
            setting.CommandColumn.ClearFilterButton.Visible = true;
            setting.CommandColumn.ShowSelectCheckbox = true;
            setting.CommandColumn.Visible = true;
            //setting.CommandColumn.Caption = " ";
            
            setting.CommandColumn.Width = Unit.Pixel(20);

            //setting.SummaryText = "jml";
            
            setting.SettingsPager.PageSizeItemSettings.Visible = true;
            setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
            setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
            setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
            setting.SettingsPager.FirstPageButton.Visible = true;
            setting.SettingsPager.LastPageButton.Visible = true;
           
            
           
            //setting.ClientSideEvents.SelectionChanged = "RowSelect";
            setting.ClientSideEvents.SelectionChanged = "GridDeliveryInvoice_SelectionChange";

            setting.CustomJSProperties = (s, e) =>
            {
                MVCxGridView grid = (MVCxGridView)s;
                int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
                int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
                //--=== List object
                object[] DATA_KEY = new object[end - startIndex];
                object[] AMOUNT = new object[end - startIndex];
                decimal TOTAL_AMOUNT = 0;
                
                for (int n = startIndex; n < end; n++)
                {
                    DATA_KEY[n - startIndex] = grid.GetRowValues(n, "DATA_KEY");
                    AMOUNT[n - startIndex] = grid.GetRowValues(n, "AMOUNT");
                    TOTAL_AMOUNT += (decimal)grid.GetRowValues(n, "AMOUNT");
                }

                e.Properties["cpDATA_KEY"] = DATA_KEY;
                e.Properties["cpAMOUNT"] = AMOUNT;
                e.Properties["cpTOTAL_AMOUNT"] = TOTAL_AMOUNT;

                e.Properties["cpVisibleRow"] = grid.VisibleRowCount;
                e.Properties["cpKeyfield"] = grid.KeyFieldName;
                
                grid.JSProperties["cpStart"] = startIndex;
                grid.JSProperties["cpEnd"] = end;
                grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
                
            };

            setting.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(
                        chckBox =>
                        {
                            chckBox.Name = "SelectAllCheckBox";
                            //chckBox.Width = 16;
                            //chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridServiceAcceptance.SelectAllRowsOnPage(chkAllRecord.GetChecked());}";
                            //chckBox.Properties.ClientSideEvents.CheckedChanged = "CheckChange";
                            //chckBox.Checked = c.Grid.Selection.Count > 1;
                            chckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                            chckBox.Checked = c.Grid.Selection.Count == c.Grid.VisibleRowCount;
                        }
                    ).Render();
            });

            
            setting.Columns.Add(col =>
            {
                col.FieldName = "DELIVERY_NO";
                col.Caption = "Delivery No";
                col.Width = Unit.Pixel(90);
                
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                col.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkDLV_NO" + content.VisibleIndex;
                            link.NavigateUrl = "javascript:void(0)";
                            link.Properties.Text = content.Text;
                            link.ClientVisible = true;
                            link.Width = 70;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnDeliveryNoClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                        }).Render();
                });
            });

            setting.Columns.Add(col =>
            {
                col.FieldName = "PO_NO";
                col.Caption = "PO Number";
                col.Width = Unit.Pixel(50);

                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.Add(col =>
            {
                col.FieldName = "CURRENCY";
                col.Caption = "Currency";
                col.Width = Unit.Pixel(50);

                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.Add(col =>
            {
                col.FieldName = "AMOUNT";
                col.Caption = "Amount";
                col.Width = Unit.Pixel(90);

                col.PropertiesEdit.DisplayFormatString = "#,##0";
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Trucking";
                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Code";
                            column.Name = "LP_CD";
                            column.FieldName = "LP_CD";
                            column.Width = Unit.Pixel(40);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
                        );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Name";
                            column.Name = "LP_NAME";
                            column.FieldName = "LP_NAME";
                            column.Width = Unit.Pixel(250);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                        }
                        );

                }
            );


            setting.Columns.Add(
             column =>
             {

                 column.Caption = "Document <br>Date";
                 column.Name = "DOCUMENT_DT";
                 column.FieldName = "DOCUMENT_DT";
                 column.ColumnType = MVCxGridViewColumnType.DateEdit;
                 column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                 column.ColumnType = MVCxGridViewColumnType.DateEdit;
                 column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                 var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                 dateEditProperties.EditFormat = EditFormat.DateTime;
                 dateEditProperties.EditFormatString = "dd.MM.yyyy";
                 dateEditProperties.UseMaskBehavior = true;
                 column.Width = Unit.Pixel(80);
                 column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                 column.Settings.AutoFilterCondition = AutoFilterCondition.Equals;

             });

            setting.Columns.Add(col =>
            {
                col.FieldName = "INVOICE_NO";
                col.Name = "INVOICE_NO";
                col.Caption = "Invoice No";
                col.Width = Unit.Pixel(100);

                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });
            
            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Upload";
                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "By";
                            column.Name = "UPLOAD_BY";
                            column.FieldName = "UPLOAD_BY";
                            column.Width = Unit.Pixel(140);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;       
                            }
                        );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Date";
                            column.Name = "UPLOAD_DT";
                            column.FieldName = "UPLOAD_DT";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;
                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                        }
                        );

                }
                );

        }).Bind(Model.GetModel<DeliveryInvoiceCreationModel>().DeliveryInvoiceCreationListData).GetHtml()
  